﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Net;
using System.IO;

namespace Tube
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            if (txtUrl.Text.Trim() != "")
            {
                string url = txtUrl.Text.Trim();
                url = convert(url);
                if (url != "")
                {
                    youtubecatch(url);
                }
            }
        }

        private string convert(string url)
        {
            url = url.Replace("www.youtube.com", "youtube.com");
            if (url.IndexOf("http://youtube.com/v/") >= 0)
            {
                url.Replace("http://youtube.com/v/", "http://youtube.com/watch?v=");
            }
            if (url.IndexOf("http://youtube.com/watch?v=") < 0)
            {
                url = "";
            }
            return (url);
        }

        private void youtubecatch(string url)
        {
            
                string buffer = getContent(url);
                try
                {
                    if (buffer.IndexOf("Error:") < 0)
                    {
                        int start = 0, end = 0;
                        string startTag = "\"fmt_url_map\": ";
                        string endTag = "\",";
                        start = buffer.IndexOf(startTag, StringComparison.CurrentCultureIgnoreCase);
                        end = buffer.IndexOf(endTag, start, StringComparison.CurrentCultureIgnoreCase);
                        string str = buffer.Substring(start + startTag.Length, end - (start + startTag.Length));
                        start = str.LastIndexOf("http");
                        str = str.Substring(start);
                        str = HttpUtility.UrlDecode(str);
                        str = str.Replace("%252", "%2");
                        litResult.Text += "<p></p><a href=\"" + str + "\">Download Link</a>";
                    }
                    else
                    {
                        litResult.Text = "<font color=\"#FF0000\"><b>" + buffer + "</b></font>";
                    }
            }
            catch (Exception)
            {
                litResult.Text = buffer;
            }
        }

        private string getContent(string url)
        {
            string buffer;
            try
            {
                WebRequest request = WebRequest.Create(url);
                WebResponse response = request.GetResponse();
                Stream stream = response.GetResponseStream();
                StreamReader reader = new StreamReader(stream);
                buffer = reader.ReadToEnd();
                stream.Dispose();
                reader.Dispose();
            }
            catch (Exception exp)
            {
                buffer = "Error: " + exp.Message.ToString();
            }

            return (buffer);
        }
    }
}
